<?php
if (!defined('VALID_CMS_ADMIN')) {
    die('ACCESS DENIED');
}
/* * **************************************************************************** */
//                          InstantCMS v1.10                                   //
//                      http://www.instantcms.ru/                              //
//                         component "SEO_PAGE" v1.2.0                         //
//                     written by Marat Fatikhov  aka Марат                    //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/* * ***************************************************************************** */
$inDB = cmsDatabase::getInstance();
define('REW_FILE', PATH . '/custom_rewrite.php');
define('COPY_FILE', PATH . '/copy_custom_rewrite.php');
define('SITE_NAME', 'http://' . $_SERVER['SERVER_NAME'] . '/');

function activatePageRoute($id) {
    $content = '';
    $content = file_get_contents(REW_FILE);
    $pattern = '/\\/\\*\\/\\/start_seo_page-' . $id . '(.*?)\\/\\/end_seo_page-' . $id . '\\*\\//uis';
    //активируем - раскомментируем
    $replacement = '//start_seo_page-' . $id . '$1//end_seo_page-' . $id;
    $content = preg_replace($pattern, $replacement, $content);
    $bits = file_put_contents(REW_FILE, $content);

    return true;
}

function deActivatePageRoute($id) {
    $content = '';
    $content = file_get_contents(REW_FILE);
    $pattern = '/\\/\\/start_seo_page-' . $id . '(\\s)(.*?)\\/\\/end_seo_page-' . $id . '(\\s)/uis';
    //деактивируем - закомментируем
    $replacement = '/*//start_seo_page-' . $id . '$1$2//end_seo_page-' . $id . '*/$3';
    $content = preg_replace($pattern, $replacement, $content);
    $bits = file_put_contents(REW_FILE, $content);

    return true;
}

cpAddPathway('SEO страницы', '?view=components&do=config&id=' . (int) $_REQUEST['id']);
echo '<h3>SEO страницы</h3>';
$opt = (isset($_REQUEST['opt'])) ? $_REQUEST['opt'] : 'list_items';

$toolmenu = array();

$toolmenu[0]['icon'] = 'newstuff.gif';
$toolmenu[0]['title'] = 'Новая SEO-страница';
$toolmenu[0]['link'] = '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=add_item';

$toolmenu[1]['icon'] = 'liststuff.gif';
$toolmenu[1]['title'] = 'Все SEO-страницы';
$toolmenu[1]['link'] = '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=list_items';

if ($opt == 'list_items' || $opt == 'show_item' || $opt == 'hide_item') {
    $toolmenu[2]['icon'] = 'edit.gif';
    $toolmenu[2]['title'] = 'Редактировать выбранные';
    $toolmenu[2]['link'] = "javascript:checkSel('?view=components&do=config&id=" . (int) $_REQUEST['id'] . "&opt=edit_item&multiple=1');";

    $toolmenu[3]['icon'] = 'show.gif';
    $toolmenu[3]['title'] = 'Активировать выбранные';
    $toolmenu[3]['link'] = "javascript:checkSel('?view=components&do=config&id=" . (int) $_REQUEST['id'] . "&opt=show_item&multiple=1');";

    $toolmenu[4]['icon'] = 'hide.gif';
    $toolmenu[4]['title'] = 'Деактивировать выбранные';
    $toolmenu[4]['link'] = "javascript:checkSel('?view=components&do=config&id=" . (int) $_REQUEST['id'] . "&opt=hide_item&multiple=1');";

    $toolmenu[5]['icon'] = 'delete.gif';
    $toolmenu[5]['title'] = 'Удалить выбранные';
    $toolmenu[5]['link'] = "javascript:checkSel('?view=components&do=config&id=" . (int) $_REQUEST['id'] . "&opt=delete_item&multiple=1');";

    $toolmenu[6]['icon'] = 'file_copy.gif';
    $toolmenu[6]['title'] = 'Управление резервными копиями файлов';
    $toolmenu[6]['link'] = '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=backup';
} else {
    $toolmenu[7]['icon'] = 'cancel.gif';
    $toolmenu[7]['title'] = 'Отмена';
    $toolmenu[7]['link'] = '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=list_items';
}


cpToolMenu($toolmenu);

$inCore->loadModel('seo_page');
$model = new cms_model_seo_page();

if (!is_writable(REW_FILE)) {//если файл недоступен для записи
    if ($opt == 'list_items' || $opt == 'add_item' || $opt == 'edit_item' || $opt == 'backup') {
        echo '<div style="margin-top:25px;">
            <font color="red">Файл <b>custom_rewrite.php</b> не доступен для записи. Проверьте права. 
            Иначе некоторые операции выполнятся некорректно</font>
            </div>';
    }
}

if ($opt == 'submit_item') {

    $error = false;

    //получаем параметры
    $request_uri = trim($inCore->request('request_uri', 'str', ''));
    $target_uri = trim($inCore->request('target_uri', 'str', ''));
    $note = $inCore->request('note', 'str', '');
    $page_title = $inCore->request('page_title', 'str', '');
    $meta_desc = $inCore->request('meta_desc', 'str', '');
    $meta_keys = $inCore->request('meta_keys', 'str', '');

    if (!$request_uri) {
        cmsCore::addSessionMessage('Вы не ввели данные в поле "Текущий URI". Поле обязательно.', 'error');
        $error = true;
    }
    //подчищаем ури и определяем компонент
    $request_uri = trim($request_uri, '/');
    $target_uri = ltrim($target_uri, '/');
    $prefix = 'http://';
    $site_name = $_SERVER['SERVER_NAME'] . '/';
    $request_uri = str_replace($prefix, '', $request_uri);
    $request_uri = str_replace($site_name, '', $request_uri);
    //определяем, есть ли слэши в адресе
    $first_slash_pos = strpos($request_uri, '/');
    if ($first_slash_pos) {
        //если есть слэши, то компонент это сегмент до первого слэша
        $component = substr($request_uri, 0, $first_slash_pos);
    } else {
        //если слэшей нет, то компонент совпадает с адресом
        $component = $request_uri;
    }
    if (!is_dir(PATH . '/components/' . $component)) {
        //если компонент не существует, считаем что это content
        $component = 'content';
    }

    $sql = "INSERT INTO `cms_seo_page` (note, component, request_uri, target_uri, page_title, meta_desc, meta_keys, published)
            VALUES ('$note', '$component', '$request_uri', '$target_uri', '$page_title', '$meta_desc', '$meta_keys', 1)";

    if (!$error && is_writable(REW_FILE)) {//в бд заносим, если файл доступен для записи
        $inDB->query($sql);
    }
    $last_id = $inDB->get_last_id('cms_seo_page');
    if (!$last_id && !$error) {
        cmsCore::addSessionMessage('Данные не записались в Базу данных. Проверьте также доступен ли для записи файл custom_rewrite.php', 'error');
        $error = true;
    }
    if ($target_uri && !$error) {
        //создаем правило
        $rules = '
                 //start_seo_page-' . $last_id . '
                 $rules[] = array(
                            \'source\'  => \'/^' . str_replace('/', '\/', $request_uri) . '$/uis\',
                            \'target\'  => \'' . SITE_NAME . $target_uri . '\',
                            \'action\'  => \'redirect-301\'
                         );

                 $rules[] = array(
                            \'source\'  => \'/^' . str_replace('/', '\/', $target_uri) . '$/uis\',
                            \'target\'  => \'' . $request_uri . '\',
                            \'action\'  => \'rewrite\'
                         );
                 //end_seo_page-' . $last_id;
        //заносим правило в файл custom_rewrite
        $content = '';
        $content = file_get_contents(REW_FILE);
        if (!$content) {
            cmsCore::addSessionMessage('Не получилось прочитать данные с файла /custom_rewrite.php. Проверьте права на чтение и на запись.', 'error');
            $error = true;
        }
        if (!$error) {
            $pattern = '/(.*?)function custom_rewrite_rules\\(\\){(.*?)/uis';
            $replacement = '$1function custom_rewrite_rules(){' . $rules . '$2';
            $content = preg_replace($pattern, $replacement, $content);
            $bits = file_put_contents(REW_FILE, $content);
            if ($bits == 0) {
                cmsCore::addSessionMessage('Не получилось записать данные в файл /custom_rewrite.php. Проверьте права на чтение и на запись.', 'error');
                $error = true;
            }
        }
    }
    if ($error) {
        $inCore->redirect('?view=components&do=config&opt=add_item&id=' . (int) $_REQUEST['id']);
    }

    header('location:?view=components&do=config&opt=list_items&id=' . (int) $_REQUEST['id']);
}

if ($opt == 'update_item') {

    $error = false;

    if (isset($_REQUEST['item_id'])) {
        //получаем параметры
        $item_id = $inCore->request('item_id', 'int', 0);
        $request_uri = trim($inCore->request('request_uri', 'str', ''));
        $target_uri = trim($inCore->request('target_uri', 'str', ''));
        $note = $inCore->request('note', 'str', '');
        $page_title = $inCore->request('page_title', 'str', '');
        $meta_desc = $inCore->request('meta_desc', 'str', '');
        $meta_keys = $inCore->request('meta_keys', 'str', '');

        //берем из базы старые данные
        $old = array();
        $old = $model->getSeoPage($item_id);
        if (!$old) {
            header('location:?view=components&do=config&opt=list_items&id=' . (int) $_REQUEST['id']);
        }
        if (!$request_uri) {
            $request_uri = $old['request_uri'];
        }
        //подчищаем ури и определяем компонент
        $request_uri = trim($request_uri, '/');
        $target_uri = ltrim($target_uri, '/');
        $prefix = 'http://';
        $site_name = $_SERVER['SERVER_NAME'] . '/';
        $request_uri = str_replace($prefix, '', $request_uri);
        $request_uri = str_replace($site_name, '', $request_uri);
        //определяем, есть ли слэши в адресе
        $first_slash_pos = strpos($request_uri, '/');
        if ($first_slash_pos) {
            //если есть слэши, то компонент это сегмент до первого слэша
            $component = substr($request_uri, 0, $first_slash_pos);
        } else {
            //если слэшей нет, то компонент совпадает с адресом
            $component = $request_uri;
        }
        if (!is_dir(PATH . '/components/' . $component)) {
            //если компонент не существует, считаем что это content
            $component = 'content';
        }

        $content = '';
        $content = file_get_contents(REW_FILE);
        if (!$content) {
            cmsCore::addSessionMessage('Не получилось прочитать данные с файла /custom_rewrite.php. Проверьте права на чтение и на запись.', 'error');
            $error = true;
        }
        //создаем правило
        $rules = '
                 //start_seo_page-' . $item_id . '
                 $rules[] = array(
                            \'source\'  => \'/^' . str_replace('/', '\/', $request_uri) . '$/uis\',
                            \'target\'  => \'' . SITE_NAME . $target_uri . '\',
                            \'action\'  => \'redirect-301\'
                         );

                 $rules[] = array(
                            \'source\'  => \'/^' . str_replace('/', '\/', $target_uri) . '$/uis\',
                            \'target\'  => \'' . $request_uri . '\',
                            \'action\'  => \'rewrite\'
                         );
                 //end_seo_page-' . $item_id;
        //проверяем изменились ли данные по ури, чтобы вносить изменения в custom_rewrite.php
        if (!$target_uri) {
            if ($old['target_uri']) {
                //удаляем
                $pattern = '/\\/\\/start_seo_page-' . $item_id . '(.*?)\\/\\/end_seo_page-' . $item_id . '/uis';
                $content = preg_replace($pattern, '', $content);
                //удаляем теги комментариев, если было отключено
                $content = preg_replace('/\\/\\*\\*\\//is', '', $content);
            }
        } else {
            if (!$old['target_uri']) {
                //добавляем новое правило
                $pattern = '/(.*?)function custom_rewrite_rules\\(\\){(.*?)/uis';
                $replacement = '$1function custom_rewrite_rules(){' . $rules . '$2';
                $content = preg_replace($pattern, $replacement, $content);
            } elseif ($request_uri != $old['request_uri'] || $target_uri != $old['target_uri']) {
                //изменяем правила
                $pattern = '/\\/\\/start_seo_page-' . $item_id . '(.*?)\\/\\/end_seo_page-' . $item_id . '/uis';
                $replacement = $rules;
                $content = preg_replace($pattern, $replacement, $content);
            }
        }
        //если нет ошибок, записываем в файл
        if (!$error) {
            $bits = file_put_contents(REW_FILE, $content);
            if ($bits == 0) {
                cmsCore::addSessionMessage('Не получилось записать данные в файл /custom_rewrite.php. Проверьте права на чтение и на запись.', 'error');
                $error = true;
            }
        }
        //если нет ошибок, обновляем запись в БД
        if (!$error) {
            $sql = "UPDATE `cms_seo_page`
                   SET note = '$note',
                       component = '$component',
                       request_uri = '$request_uri',
                       target_uri = '$target_uri',
                       page_title = '$page_title',
                       meta_desc = '$meta_desc',
                       meta_keys = '$meta_keys'
                   WHERE id = $item_id
                   LIMIT 1";
            $inDB->query($sql);
        }
        if ($error) {
            $inCore->redirect('?view=components&do=config&opt=edit_item&id=' . (int) $_REQUEST['id'] . '&item_id=' . $item_id);
        }
    }
    if (!isset($_SESSION['editlist']) || @sizeof($_SESSION['editlist']) == 0) {
        header('location:?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=list_items');
    } else {
        header('location:?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=edit_item');
    }
}

if ($opt == 'delete_item') {
    if (!isset($_REQUEST['item'])) {
        if (isset($_REQUEST['item_id'])) {
            $model->deleteSeoPage((int) $_REQUEST['item_id']);
        }
    } else {
        $model->deleteSeoPages($_REQUEST['item']);
    }
    header('location:?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=list_items');
}

if ($opt == 'show_item') {
    if (!isset($_REQUEST['item'])) {
        if (isset($_REQUEST['item_id'])) {
            dbShow('cms_seo_page', (int) $_REQUEST['item_id']);
            activatePageRoute($_REQUEST['item_id']);
        }
        echo '1';
        exit;
    } else {
        dbShowList('cms_seo_page', $_REQUEST['item']);
        foreach ($_REQUEST['item'] as $item_id) {
            activatePageRoute($item_id);
        }
        $opt = 'list_items';
    }
}

if ($opt == 'hide_item') {
    if (!isset($_REQUEST['item'])) {
        if (isset($_REQUEST['item_id'])) {
            dbHide('cms_seo_page', (int) $_REQUEST['item_id']);
            deActivatePageRoute($_REQUEST['item_id']);
        }
        echo '1';
        exit;
    } else {
        dbHideList('cms_seo_page', $_REQUEST['item']);
        foreach ($_REQUEST['item'] as $item_id) {
            deActivatePageRoute($item_id);
        }
        $opt = 'list_items';
    }
}


if ($opt == 'list_items') {

    //TABLE COLUMNS
    $fields = array();

    $fields[0]['title'] = 'id';
    $fields[0]['field'] = 'id';
    $fields[0]['width'] = '30';

    $fields[1]['title'] = 'Текущий URI';
    $fields[1]['field'] = 'request_uri';
    $fields[1]['width'] = '';
    $fields[1]['link'] = '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=edit_item&item_id=%id%';
    $fields[1]['filter'] = 30;
    $fields[1]['maxlen'] = 80;

    $fields[2]['title'] = 'URI замены';
    $fields[2]['field'] = 'target_uri';
    $fields[2]['width'] = '';
    $fields[2]['filter'] = 30;
    $fields[2]['maxlen'] = 80;

    $fields[3]['title'] = 'Компонент';
    $fields[3]['field'] = 'component';
    $fields[3]['width'] = '';
    $fields[3]['filter'] = 1;
    $fields[3]['filterlist'] = $model->cpGetList('cms_components');
    $fields[3]['maxlen'] = 80;

    $fields[4]['title'] = 'Примечание';
    $fields[4]['field'] = 'note';
    $fields[4]['width'] = '';
    $fields[4]['maxlen'] = 80;

    $fields[5]['title'] = 'Показ';
    $fields[5]['field'] = 'published';
    $fields[5]['width'] = '100';
    $fields[5]['do'] = 'opt';
    $fields[5]['do_suffix'] = '_item';

    //ACTIONS
    $actions = array();
    $actions[0]['title'] = 'Посмотреть на сайте';
    $actions[0]['icon'] = 'search.gif';
    $actions[0]['link'] = 'http://' . $_SERVER['SERVER_NAME'] . '/%request_uri%';

    $actions[1]['title'] = 'Редактировать';
    $actions[1]['icon'] = 'edit.gif';
    $actions[1]['link'] = '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=edit_item&item_id=%id%';

    $actions[2]['title'] = 'Удалить';
    $actions[2]['icon'] = 'delete.gif';
    $actions[2]['confirm'] = 'Удалить SEO-страницу?';
    $actions[2]['link'] = '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=delete_item&item_id=%id%';

    //Print table
    cpListTable('cms_seo_page', $fields, $actions, '', 'id DESC');
}

if ($opt == 'add_item' || $opt == 'edit_item') {
    //сообщение об ошибке
    $messages = cmsCore::getSessionMessages();
    if ($messages) {
        ?>
        <div style="line-height:32px; font-size:18px;">
            <?php foreach ($messages as $message) { ?>
                <b><?php echo $message; ?></b>
            <?php } ?>
        </div>
        <?php
    }
    cmsCore::clearSessionMessages();
    if ($opt == 'add_item') {
        echo '<h3>Добавить SEO-страницу</h3>';
        cpAddPathway('Добавить SEO-страницу', '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=add_item');
    } else {
        if (isset($_REQUEST['multiple'])) {
            if (isset($_REQUEST['item'])) {
                $_SESSION['editlist'] = $_REQUEST['item'];
            } else {
                echo '<p class="error">Нет выбранных объектов!</p>';
                return;
            }
        }

        $ostatok = '';

        if (isset($_SESSION['editlist'])) {
            $id = array_shift($_SESSION['editlist']);
            if (sizeof($_SESSION['editlist']) == 0) {
                unset($_SESSION['editlist']);
            } else {
                $ostatok = '(На очереди: ' . sizeof($_SESSION['editlist']) . ')';
            }
        } else {
            $id = (int) $_REQUEST['item_id'];
        }

        $mod = array();
        $mod = $model->getSeoPage($id);
        if (!$mod) {
            header('location:?view=components&do=config&opt=list_items&id=' . (int) $_REQUEST['id']);
        }

        echo '<h3>Просмотр SEO-страницы</h3>';
        cpAddPathway('SEO-страницы', '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=list_items');
        cpAddPathway('SEO-страница-' . $mod['id'], '?view=components&do=config&id=' . (int) $_REQUEST['id'] . '&opt=edit_item&item_id=' . $id);
    }
    ?>
    <form action="index.php?view=components&amp;do=config&amp;id=<?php echo (int) $_REQUEST['id']; ?>" method="post" name="addform" id="addform">
        <table width="100%" border="0" cellpadding="0" cellspacing="10" class="proptable">
            <tr>
                <td valign="top" width="350px">
                    <strong>Текущий URI:</strong><br>
                    <span class="hinttext">
                        <b><font color="red">Обязательный пункт.</font></b> Остальные пункты необязательны.<br>
                        Например, для страницы http://ваш_сайт.ru/catalog/item7.html указываем catalog/item7.html
                    </span>
                </td>
                <td valign="top">
                    <input name="request_uri" type="text" size="100" maxlenght="200" value="<?php echo $mod['request_uri']; ?>">
                </td>
            </tr>
            <tr>
                <td valign="top" width="350px">
                    <strong>URI замены:</strong><br>
                    <span class="hinttext">
                        Например, чтобы получить url http://ваш_сайт.ru/statja.html указываем statja.html .
                        Или для url http://ваш_сайт.ru/kategoria/avtomobili указываем kategoria/avtomobili .
                        Любой уровень вложенности, любой url. Не забудьте проверить, чтобы такого url на сайте не существовало.
                    </span>
                </td>
                <td valign="top">
                    <input name="target_uri" type="text" size="100" maxlenght="200" value="<?php echo $mod['target_uri']; ?>">
                </td>
            </tr>
            <tr>
                <td valign="top" width="350px">
                    <strong>Примечание:</strong><br>
                    <span class="hinttext">
                        Любое, чтобы удобно было различить страницу в списке.
                    </span>
                </td>
                <td valign="top">
                    <textarea name="note" rows="3" style="width:690px"><?php echo $mod['note']; ?></textarea>
                </td>
            </tr>
            <tr>
                <td valign="top" width="350px">
                    <strong>Заголовок страницы:</strong><br>
                    <span class="hinttext">
                        Значение заголовка между тегами <b>&#60title&#62&#60/title&#62</b>
                    </span>
                </td>
                <td valign="top">
                    <input name="page_title" type="text" size="100" maxlenght="200" value="<?php echo $mod['page_title']; ?>">
                </td>
            </tr>
            <tr>
                <td valign="top" width="350px">
                    <strong>Ключевые слова:</strong><br>
                    <span class="hinttext">
                        Через запятую.
                    </span>
                </td>
                <td valign="top">
                    <textarea name="meta_keys" rows="3" style="width:690px"><?php echo $mod['meta_keys']; ?></textarea>
                </td>
            </tr>
            <tr>
                <td valign="top" width="350px">
                    <strong>Описание:</strong><br>
                    <span class="hinttext">
                        Через запятую.
                    </span>
                </td>
                <td valign="top">
                    <textarea name="meta_desc" rows="3" style="width:690px"><?php echo $mod['meta_desc']; ?></textarea>
                </td>
            </tr>
        </table>
        <p>
            <label>
                <input name="add_mod" type="submit" id="add_mod" <?php
    if ($opt == 'add_item') {
        echo 'value="Добавить SEO-страницу"';
    } else {
        echo 'value="Сохранить изменения"';
    }
    ?> />
            </label>
            <label>
                <input name="back2" type="button" id="back2" value="Отмена" onclick="window.location.href='index.php?view=components&do=config&id=<?php echo $_REQUEST['id']; ?>';"/>
            </label>
            <input name="opt" type="hidden" id="do" <?php
                   if ($opt == 'add_item') {
                       echo 'value="submit_item"';
                   } else {
                       echo 'value="update_item"';
                   }
    ?> />
                   <?php
                   if ($opt == 'edit_item') {
                       echo '<input name="item_id" type="hidden" value="' . $mod['id'] . '" />';
                   }
                   ?>
        </p>
    </form>
    <div>
        <p><b><font color="red">ВНИМАНИЕ.</font></b> Обязательный пункт "Текущий URI". Любой остальной пункт заполняется по желанию. Если какой-то пункт не
            заполнен, то для страницы сохраняются значения по умолчанию, определенные компонентами или системой.<br>
            <b><font color="red">ВАЖНО.</font></b> Следите, чтобы в поле "URI замены" был уникальный для сайта URI. Иначе возможно некорректное перенаправление.<br>
            Данные для перенаправления с админки вносятся в файл /custom_rewrite.php в корне сайта программно. Поэтому возможны непредвиденные сбои. Рекомендуется перед
            внесением изменений сохранить резервную копию указанного файла.</p>
    </div>
    <?php
}

if ($opt == 'backup') {
    if (isset($_REQUEST['copy'])) {   //копия файла
        $is_copy = copy(REW_FILE, COPY_FILE);
        if ($is_copy) {
            echo '<div style="margin-top:25px;">
            <font color="green">Содержимое файла <b>custom_rewrite.php</b> скопировано в файл <b>copy_custom_rewrite.php</b></font>
            </div>';
        }else{
            echo '<div style="margin-top:25px;">
            <font color="red">Содержимое файла <b>custom_rewrite.php</b> не скопировано в файл <b>copy_custom_rewrite.php</b>
            Проверьте права на запись в файл.</font>
            </div>';
        }
    }
    if (isset($_REQUEST['restore'])) { //восстановление из копии
        $is_restore = copy(COPY_FILE, REW_FILE);
        if ($is_restore) {
            echo '<div style="margin-top:25px;">
            <font color="green">Содержимое файла <b>custom_rewrite.php</b> восстановлено из файла <b>copy_custom_rewrite.php</b></font>
            </div>';
        }else{
            echo '<div style="margin-top:25px;">
            <font color="red">Содержимое файла <b>custom_rewrite.php</b>  не восстановлено из файла <b>copy_custom_rewrite.php.</b>
            Проверьте существует ли файл копии и права на запись в файлы.</font>
            </div>';
        }
    }
    if (isset($_REQUEST['restore_bd'])) { //восстановление из БД
        //берем записи из бд
        $items = array();
        $content = '';
        $items = $inDB->get_table('`cms_seo_page`', 'target_uri != \'\'');
        //готовим содержимое файла
        $content = '<?php
            function custom_rewrite_rules(){';
        //заносим правила
        foreach ($items as $item) {
            $rule = '//start_seo_page-' . $item['id'] . '
                 $rules[] = array(
                            \'source\'  => \'/^' . str_replace('/', '\/', $item['request_uri']) . '$/uis\',
                            \'target\'  => \'' . SITE_NAME . $item['target_uri'] . '\',
                            \'action\'  => \'redirect-301\'
                         );

                 $rules[] = array(
                            \'source\'  => \'/^' . str_replace('/', '\/', $item['target_uri']) . '$/uis\',
                            \'target\'  => \'' . $item['request_uri'] . '\',
                            \'action\'  => \'rewrite\'
                         );
                 //end_seo_page-' . $item['id'];
            if (!$item['published']) {
                $rule = '/*' . $rule . '*/';
            }
            $content .= '
                ' . $rule;
        }

        $content .= '
    //строчку ниже не убирать, это заглушка. Чтобы не выкидывало на 404 страницу при пустом файле
    //применительно к компоненту seo-page
    $rules[] = \'\';
    return $rules;
}
?>';

        $bits = file_put_contents(REW_FILE, $content);
        if ($bits) {
            echo '<div style="margin-top:25px;">
            <font color="green">Содержимое файла <b>custom_rewrite.php</b> восстановлено из базы данных</font>
            </div>';
        }else{
            echo '<div style="margin-top:25px;">
            <font color="red">Содержимое файла <b>custom_rewrite.php</b>  не восстановлено из базы данных. 
            Проверьте права на запись в файл.</font>
            </div>';
        }
    }
    //проверка прав на запись файла копии
    if (file_exists(COPY_FILE)) {//если файл существует
        if (!is_writable(COPY_FILE)) {//если файл недоступен для записи
            echo '<div style="margin-top:25px;">
            <font color="red">Файл-копия <b>copy_custom_rewrite.php</b> не доступен для записи. Проверьте права. 
            Иначе некоторые операции выполнятся некорректно</font>
            </div>';
        }
    } else {
        echo '<div style="margin-top:25px;">
            <font color="red">Файл-копия <b>copy_custom_rewrite.php</b> не cуществует.
            Восстановление из копии файла <b>custom_rewrite.php</b> не возможно. </font>
            </div>';
    }
    ?><form name="backup" action="index.php?view=components&amp;do=config&amp;id=<?php echo (int) $_REQUEST['id']; ?>" method="post">
        <input type="hidden" name="opt" value="backup">
        <div style="margin-top: 25px;">
            <div>
                <input type="submit" value="Сохранить копию файла" name="copy">
                позволяет сохранить копию файла <b>custom_rewrite.php</b> в файл <b>copy_custom_rewrite.php</b> 
            </div>
            <div style="margin-top: 15px">
                <input type="submit" value="Восстановить файл из копии" name="restore">
                позволяет восстановить файл <b>custom_rewrite.php</b> из сохраненной копии <b>copy_custom_rewrite.php</b> 
            </div>
            <div style="margin-top: 15px">
                <input type="submit" value="Восстановить файл из БД" name="restore_bd">
                позволяет восстановить файл <b>custom_rewrite.php</b> из Базы данных. 
            </div>
        </div>
    </form>
    <?php
}
?>
